<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_HotelRelPaxDist ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_HotelRelPaxDist extends AbstractStructArrayBase
{
    /**
     * The RelPaxDist
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_HotelRelPaxDist[]
     */
    public $RelPaxDist;
    /**
     * Constructor method for ArrayOfJP_HotelRelPaxDist
     * @uses ArrayOfJP_HotelRelPaxDist::setRelPaxDist()
     * @param \StructType\JP_HotelRelPaxDist[] $relPaxDist
     */
    public function __construct(array $relPaxDist = array())
    {
        $this
            ->setRelPaxDist($relPaxDist);
    }
    /**
     * Get RelPaxDist value
     * @return \StructType\JP_HotelRelPaxDist[]|null
     */
    public function getRelPaxDist()
    {
        return $this->RelPaxDist;
    }
    /**
     * Set RelPaxDist value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelRelPaxDist[] $relPaxDist
     * @return \ArrayType\ArrayOfJP_HotelRelPaxDist
     */
    public function setRelPaxDist(array $relPaxDist = array())
    {
        foreach ($relPaxDist as $arrayOfJP_HotelRelPaxDistRelPaxDistItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_HotelRelPaxDistRelPaxDistItem instanceof \StructType\JP_HotelRelPaxDist) {
                throw new \InvalidArgumentException(sprintf('The RelPaxDist property can only contain items of \StructType\JP_HotelRelPaxDist, "%s" given', is_object($arrayOfJP_HotelRelPaxDistRelPaxDistItem) ? get_class($arrayOfJP_HotelRelPaxDistRelPaxDistItem) : gettype($arrayOfJP_HotelRelPaxDistRelPaxDistItem)), __LINE__);
            }
        }
        $this->RelPaxDist = $relPaxDist;
        return $this;
    }
    /**
     * Add item to RelPaxDist value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelRelPaxDist $item
     * @return \ArrayType\ArrayOfJP_HotelRelPaxDist
     */
    public function addToRelPaxDist(\StructType\JP_HotelRelPaxDist $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_HotelRelPaxDist) {
            throw new \InvalidArgumentException(sprintf('The RelPaxDist property can only contain items of \StructType\JP_HotelRelPaxDist, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RelPaxDist[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_HotelRelPaxDist|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_HotelRelPaxDist|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_HotelRelPaxDist|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_HotelRelPaxDist|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_HotelRelPaxDist|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RelPaxDist
     */
    public function getAttributeName()
    {
        return 'RelPaxDist';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_HotelRelPaxDist
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
